"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const typedi_1 = require("typedi");
const index_1 = require("../index");
function preparePath(path) {
    const newPath = index_1.App.expressApp.get("baseRoute") + path;
    return newPath;
}
function methodDecorator(target, descriptor, path, method, middlewares = null, arrValidator = [], ignore = false) {
    const self = typedi_1.Container.get(target.constructor);
    const pathPrepared = ignore ? path : preparePath(path);
    if (middlewares) {
        index_1.App.expressApp[method](pathPrepared, arrValidator, middlewares, descriptor.value.bind(self));
    }
    else {
        index_1.App.expressApp[method](pathPrepared, descriptor.value.bind(self));
    }
    return descriptor;
}
exports.Http = {
    Get: (path, middlewares = null, arrValidator = [], ignore = false) => {
        return (target, propertyKey, descriptor) => {
            return methodDecorator(target, descriptor, path, 'get', middlewares, arrValidator, ignore);
        };
    },
    Post: (path, middlewares = null, arrValidator = [], ignore = false) => {
        return (target, propertyKey, descriptor) => {
            return methodDecorator(target, descriptor, path, 'post', middlewares, arrValidator, ignore);
        };
    },
    Put: (path, middlewares = null, arrValidator = [], ignore = false) => {
        return (target, propertyKey, descriptor) => {
            return methodDecorator(target, descriptor, path, 'put', middlewares, arrValidator, ignore);
        };
    },
    Delete: (path, middlewares = null, arrValidator = [], ignore = false) => {
        return (target, propertyKey, descriptor) => {
            return methodDecorator(target, descriptor, path, 'delete', middlewares, arrValidator, ignore);
        };
    }
};
//# sourceMappingURL=Route.js.map